/********************************** (C) COPYRIGHT *******************************
 * File Name          : main.c
 * Author             : WCH
 * Version            : V1.0.0
 * Date               : 2020/04/30
 * Description        : Main program body.
 * Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
 * SPDX-License-Identifier: Apache-2.0
 *******************************************************************************/

/*
 *@Note
 ڴӡ̣
 USART1_Tx(PA9)
 ʾʹ USART1(PA9) ӡԿ

*/

#include "debug.h"
#include "stdio.h"
#include "stdlib.h"
#include "stdbool.h"
#include "cJSON.h"
#include "usart1.h"


/* Global typedef */

/* Global define */

/* Global Variable */
void USART1_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

char  *strJSON; //ɹcJSON_Printӡ
cJSON *objJson;
uint8_t  rxBuffer[128];
uint16_t count=0;
volatile bool bFlagOneFrame = false;

void json_pack(void);
void json_analysis(void);
void cJsonQueParse(char *str);

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    u8 i = 0;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    Delay_Init();
    USART_Printf_Init(115200);
    USART1_Init(115200);

    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("This is printf example\r\n");

    for(i=0;i<10;i++)
    {
        json_pack();
    }

    for(i=0;i<10;i++)
    {
        json_analysis();
    }

    while(1)
    {
        //ڷ {"SV":60,"KP":5.0,"KI":100,"KD":300}
        if(true == bFlagOneFrame)
        {
            printf("\r\n start\r\n");
            cJsonQueParse((char *)rxBuffer);
            count = 0;
            bFlagOneFrame = false;
        }
    }
}

//ԴJSON
void json_pack(void)
{
    static uint8_t number_data;
    cJSON * usr;
    char  *data;
    number_data=number_data+1;    //ģ
    if(number_data>100)
    {
        number_data=0;
    }
    usr=cJSON_CreateObject();   //ݶ
    cJSON_AddItemToObject(usr, "A", cJSON_CreateNumber(number_data));  //ڵ
    cJSON_AddItemToObject(usr, "B", cJSON_CreateString("hello"));      //ڵַ
    cJSON_AddItemToObject(usr, "C", cJSON_CreateString("˧"));         //ڵӺ
    data = cJSON_Print(usr);   //jsonʽӡַʽ(\r\n)
    //data = cJSON_PrintUnformatted(usr);   //jsonʽӡַʽ(û\r\n)
     printf("%s",data);         //ͨڴӡ
    /********************/
    /*      ͷڴ                */
    /*********************/
    cJSON_Delete(usr);
    free(data);
}

//ԽJSON
void json_analysis(void)
{

    cJSON *json,*json_one,*json_two,*json_three;
    char* out="{\"one\":\"long\",\"two\":\"2\",\"three\":3}";

    json = cJSON_Parse(out); //õַjsonʽ
    /****************************/
    /*    ԽJSONӡ   */
    /***************************/
    //char *out_data = cJSON_Print(json);   //jsonʽӡַʽ
    //printf("%s",out_data);

    json_one = cJSON_GetObjectItem( json , "one" );  //jsonȡֵ
    json_two = cJSON_GetObjectItem( json , "two" );//jsonȡֵ
    json_three = cJSON_GetObjectItem( json , "three" );//jsonȡֵ

    printf("\r\none:%s   two:%d   three:%d",json_one->valuestring,json_two->valueint,json_three->valueint);

    cJSON_Delete(json);  //ͷڴ
}


void cJsonQueParse(char *str)
{
//    cJSON* cjson = cJSON_Parse(json_string);       //JSONַתJSONṹ
    cJSON* cjson = cJSON_Parse(str);   //JSONַתJSONṹ
    if(cjson == NULL)
    {
        printf("cjson parse error...\r\n");
    }
    else
    {
        char *json_data = cJSON_PrintUnformatted(cjson); //JSONݽṹתΪJSONַ
        printf("%s\n",json_data);//ַ

        printf("/*********************¾ȡ**********************/\n");
        double fSV = cJSON_GetObjectItem(cjson,"SV")->valuedouble;  //
        printf("SV: %.4f\n",fSV);
        double fKP = cJSON_GetObjectItem(cjson,"KP")->valuedouble;  //
        printf("KP: %.4f\n",fKP);
        double fKI = cJSON_GetObjectItem(cjson,"KI")->valuedouble;  //
        printf("KI: %.4f\n",fKI);
        double fKD = cJSON_GetObjectItem(cjson,"KD")->valuedouble;  //
        printf("KD: %.4f\n",fKD);

        //ͷڴ
        free(json_data);
        cJSON_Delete(cjson); //ṹ
    }
}


/********************************************************************************************************
** : USART1_IRQHandler,  1жϷ
********************************************************************************************************/
void USART1_IRQHandler(void)
{
    uint8_t ucTemp;
    if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET) //жϲ
    {
         USART_ClearITPendingBit(USART1,USART_IT_RXNE);    //жϱ־
         ucTemp = USART_ReceiveData(USART1);               //
         rxBuffer[count++] = ucTemp;
         if(0x0A == ucTemp)
         {
             bFlagOneFrame = true;
         }
//         USART_SendData(USART1, ucTemp);                   //
    }
}
